//
//  HelloWorldANE.m
//  HelloWorldANE
//
//  Created by tshiraishi on 2012/08/20.
//  Copyright (c) 2012年 mushikago.inc. All rights reserved.
//

#import "HelloWorldANE.h"


@implementation HelloWorldANE

@end

FREObject GetHelloWorld(FREContext ctx, void* funcData, uint32_t argc, FREObject argv[]) {
    
    ///ここからアプリ内課金用に追加///
    const char *str = "Hello, app in purchase!";
    
    InAppPurchaseManager *appMng = [[InAppPurchaseManager alloc]init];
    
    appMng.myContext = ctx; //step5
    
    if (appMng.canMakePurchases) {
        [appMng requestProductData:@"com.mushikago.InAppPurchaseXcode.unLock"];
    }else {
        str = "課金が許可されていません。";
    }
    
    ///ここまで
    
    FREObject retStr;
    FRENewObjectFromUTF8(strlen(str)+1, (const uint8_t *)str, &retStr);
    
    return retStr;
}

void ContextInitializer(void* extData, const uint8_t* ctxType, FREContext ctx,
                        uint32_t* numFunctionsToTest, const FRENamedFunction** functionsToSet) {
    *numFunctionsToTest = 1;
    FRENamedFunction* func = (FRENamedFunction*)malloc(sizeof(FRENamedFunction)*1);
    func[0].name = (const uint8_t*)"GetHelloWorld"; //ネイティブ拡張関数名
    func[0].functionData = NULL;
    func[0].function = &GetHelloWorld; //ネイティブコード関数のポインタ
    
    *functionsToSet = func;
}
void ContextFinalizer(FREContext ctx) {
    return;
}

void ExtInitializer(void** extDataToSet, FREContextInitializer* ctxInitializerToSet,
                    FREContextFinalizer* ctxFinalizerToSet) {
    *extDataToSet = NULL;
    *ctxInitializerToSet = &ContextInitializer;
    *ctxFinalizerToSet = &ContextFinalizer;
}
void ExtFinalizer(void* extData) {
    return;
}
